/*
The Mecanum-wheel AI robot "DanVI,"
Developed by: Metaplace Co., Ltd.(T.033-252-4787)
BuiltIn(ATMEGA32U4-MU) 
PCB_ver 2.0
SMC(6850)MOTER
*/

// 디지털핀 번호 정의
// LED가 연결된 핀 번호는 디지털 핀 13번으로 설정
#define led_pin 13     

// setup() 함수는 부팅 시에만 한 번 실행되는 함수
void setup()
{
  // 시리얼 통신 초기화: 컴퓨터와의 데이터 통신 속도를 9600bps(bits per second)로 설정
  // 이 설정은 Serial Monitor에서 데이터를 송수신할 때 사용됨
  Serial.begin(9600);
  
  // 디지털 핀 모드 설정: led_pin으로 정의된 13번 핀을 출력 모드(OUTPUT)로 설정
  // 이 핀을 통해 LED에 전원을 공급하거나 끌 수 있음
  pinMode(led_pin, OUTPUT);
}
// setup() 함수 종료

// loop() 함수는 메인 프로그램으로, Arduino가 켜져 있는 동안 계속 반복 실행
void loop()
{
  // LED ON: 13번 핀(led_pin)에 HIGH 신호를 보내 LED를 켭니다.
  // HIGH 신호는 디지털 핀에 전압을 공급하여 연결된 LED가 켜지도록 합니다.
  digitalWrite(led_pin, HIGH);
  
  // 시리얼 모니터에 "LED ON" 메시지를 출력합니다.
  // 이 메시지는 컴퓨터의 시리얼 모니터에서 LED가 켜졌다는 사실을 확인하는 용도로 사용됩니다.
  Serial.println("LED ON");

  // 대기 시간: 1000 밀리초(1초) 동안 프로그램을 일시 정지합니다.
  // 이 지연 시간 동안 LED는 켜진 상태를 유지합니다.
  delay(1000);
  
  // LED OFF: 13번 핀(led_pin)에 LOW 신호를 보내 LED를 끕니다.
  // LOW 신호는 디지털 핀의 전압을 차단하여 연결된 LED가 꺼지도록 합니다.
  digitalWrite(led_pin, LOW);
  
  // 시리얼 모니터에 "LED OFF" 메시지를 출력합니다.
  // 이 메시지는 컴퓨터의 시리얼 모니터에서 LED가 꺼졌다는 사실을 확인하는 용도로 사용됩니다.
  Serial.println("LED OFF");
  
  // 대기 시간: 1000 밀리초(1초) 동안 프로그램을 일시 정지합니다.
  // 이 지연 시간 동안 LED는 꺼진 상태를 유지합니다.
  delay(1000);

} 
// loop() 함수 종료

