/*
The Mecanum-wheel AI robot "DanVI,"
Developed by: Metaplace Co., Ltd.(T.033-252-4787)
BuiltIn(ATMEGA32U4-MU) 
PCB_ver 2.0
SMC(6850)MOTER
*/


// 디지털핀 번호 정의
// Buzzer(부저)가 연결된 핀번호는 디지털핀 6번으로 설정합니다. 
#define buzzer_pin 6                  

// setup() 함수는 부팅 시에만 한 번 실행되는 함수입니다.
void setup()
{
  // 시리얼 통신 초기화: 컴퓨터와의 데이터 통신 속도를 9600bps(bits per second)로 설정합니다.
  // 이 설정은 Serial Monitor에서 데이터를 송수신할 때 사용됩니다.
  Serial.begin(9600);

  // 디지털 핀 모드 설정: buzzer_pin(6번 핀)을 출력 모드(OUTPUT)로 설정합니다.
  // 이 핀은 부저(Buzzer)를 제어하는 데 사용됩니다.
  pinMode(buzzer_pin, OUTPUT);
}
// setup() 함수 종료


// loop() 함수는 메인 프로그램으로, Arduino가 켜져 있는 동안 계속 반복 실행됩니다.
void loop() {
  // BUZZER ON: buzzer_pin(6번 핀)에 HIGH 신호를 보내 부저(Buzzer)를 켭니다.
  digitalWrite(buzzer_pin, HIGH);
  Serial.println("BUZZER ON");

  // 2초 동안 부저를 울립니다.
  delay(5000);

  // BUZZER OFF: buzzer_pin(6번 핀에 LOW 신호를 보내 부저(Buzzer)를 끕니다.
  digitalWrite(buzzer_pin, LOW);
  Serial.println("BUZZER OFF");

  // 1초 동안 부저를 끈 상태를 유지합니다.
  delay(1000);
}