/*
The Mecanum-wheel AI robot "DanVI,"
Developed by: Metaplace Co., Ltd.(T.033-252-4787)
BuiltIn(ATMEGA32U4-MU) 
PCB_ver 2.0
SMC(6850)MOTER
*/

// 부팅시 한 번 실행되는 함수
void setup()
{
  // 시리얼 통신 초기화, 전송 속도는 9600bps(bits per second)로 설정
  Serial.begin(9600);
  // 블루투스 시리얼 통신 초기화, 전송 속도는 9600bps(bits per second)로 설정
  Serial1.begin(9600);    
}
// setup() 함수 종료

// loop() 함수는 메인 프로그램으로, Arduino가 켜져 있는 동안 계속 반복 실행됩니다.
void loop() 
{
  // 블루투스 시리얼 통신에서 명령 수신 확인
  if (Serial1.available())
  { 
    // Serial1[하드웨어]에서 데이터가 있으면, 해당 데이터를 시리얼 모니터에 출력
    Serial.write(Serial1.read());  // 블루투스에서 받은 내용을 시리얼 모니터에 출력
  }

  // 시리얼 통신에서 명령 수신 확인
  if (Serial.available())
  {
    // 시리얼 모니터에서 데이터가 있으면, 해당 데이터를 블루투스 측으로 출력
    Serial1.write(Serial.read());  // 시리얼 모니터에서 받은 내용을 블루투스 측에 출력
  }

/*
"No line ending [9600 baud]"
  - "No line ending": 시리얼 모니터에서 명령어를 전송할 때, 아무런 추가 문자를 보내지 않도록 설정합니다.
  - 이 설정은 시리얼 모니터의 하단에서 "No line ending" 옵션을 선택함으로써 활성화됩니다.

- "9600 baud": 시리얼 통신 속도가 9600bps(bits per second)로 설정되어 있어야 합니다.
  - 이 속도는 시리얼 모니터와 Arduino 간의 데이터 전송 속도를 의미하며, 
  - 시리얼 모니터의 하단에서 9600으로 설정해야 합니다.
  - Arduino의 `Serial.begin(9600);` 구문과 일치해야 통신이 원활하게 이루어집니다.

AT  (OK)
  - "AT": 블루투스 모듈의 상태를 확인하는 명령어입니다.
  - 시리얼 모니터에 "AT"를 입력하고 전송하면, 블루투스 모듈이 제대로 작동 중인지 확인할 수 있습니다.
  - 만약 블루투스 모듈이 정상적으로 작동하고 있다면, 시리얼 모니터에 "OK"라는 응답이 출력됩니다.

AT+NAME이름 (OK+Set:이름)
- "AT+NAME이름": 블루투스 모듈의 이름을 설정하는 명령어입니다.
  - "이름" 부분을 원하는 블루투스 기기의 이름으로 변경하여 입력합니다.
  - 명령어를 전송하면, 시리얼 모니터에 "OK+Set:이름"이라는 응답이 출력됩니다. 
  - 이 응답은 이름이 성공적으로 설정되었음을 나타냅니다.
  - 예를 들어, "OK+Set:Metaplace"라고 출력되면 블루투스 모듈의 이름이 "Metaplace"로 설정된 것입니다.
*/

}